
static char rcsid[] =
	"$Id: globals.c,v 1.34 2001/02/05 22:57:09 pvmsrc Exp $";

#include "pvm_test.h"
#include "test_list.h"


/* Globals */

test_errmsg		*ERRMSGS = (test_errmsg *) NULL;

FILE	*outfile = (FILE *) NULL;

struct timeval	TRECV_TM;

char	*diff_arch[ MAX_HOST ];	/* array of distinct archs */
char	*hostpool[ MAX_HOST ];	/* array of non-master hosts */
char	*hostarch[ MAX_HOST ];	/* array of architectures */

int		num_hosts;

char    *outfilename;
char	*infilename;

int		MYPARENT;

int		all_combos;
int		all_tests;
int		all_messaging;
int		all_routine;
int		all_funnel_nodata;
int		all_funnel_data;
int		all_head_nodata;
int		all_head_data;
int		all_triangle_nodata;
int		all_triangle_data;
int		all_perf;

int		slave_spawn_flags;		/* extra slave spawn flags */

int		num_messages;			/* # of messages for mp tests */
int		messages_length;		/* length of messages */

int		timing_average;			/* do average comm time? */	
int		timing_total;			/* do total comm time? */

int		start_size;				/* params for perf tests */
int		max_size;

int		num_iters;				/* # of iterations for each test */

int		newpvm = 0;				/* did we start PVM? */

int		incr;

int		vflag;					/* verbose output flag */


/**************************/
/*  List of test modules  */
/**************************/

test_module module_list[] =
{
	{ "pvm_mstat correct", 			
		{ 0, ALL_HOSTS, ALL_HOSTS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_mstat_correct, { 0, 0, 0, 0, 0, 0, 0, 0 },
		(vfp) test_slave_null, { 0, 0, 0, 0, 0, 0, 0, 0 } },
	{ "pvm_mstat incorrect",
		{ 0, 1, 1 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_mstat_incorrect, { 0, 0, 0, 0, 0, 0, 0, 0 },
		(vfp) test_slave_null, { 0, 0, 0, 0, 0, 0, 0, 0 } },
	{ "pvm_addhosts correct",
		{ 0, 1, ALL_HOSTS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_addhosts_correct, { 0, 0, 0, 0, 0, 0, 0, 0 },
		(vfp) test_slave_null, { 0, 0, 0, 0, 0, 0, 0, 0 } },
	{ "pvm_addhosts incorrect",
		{ 0, 1, ALL_HOSTS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_addhosts_incorrect, { 0, 0, 0, 0, 0, 0, 0, 0 },
		(vfp) test_slave_null, { 0, 0, 0, 0, 0, 0, 0, 0 } },
	{ "pvm_delhosts correct",
		{ 0, ALL_HOSTS, 1 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_delhosts_correct, { 0, 0, 0, 0, 0, 0, 0, 0 },
		(vfp) test_slave_null, { 0, 0, 0, 0, 0, 0, 0, 0 } },
	{ "pvm_delhosts incorrect",
		{ 0, ALL_HOSTS, 1 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_delhosts_incorrect, { 0, 0, 0, 0, 0, 0, 0, 0 },
		(vfp) test_slave_null, { 0, 0, 0, 0, 0, 0, 0, 0 } },
	{ "Race pvm_addhosts()-pvm_config()",
		{ 0, 1, ALL_HOSTS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_race_addhosts_config, { 0, 0, 0, 0, 0, 0, 0, 0 },
		(vfp) test_slave_null, { 0, 0, 0, 0, 0, 0, 0, 0 } },
	{ "Race pvm_delhosts()-pvm_config()",
		{ 0, ALL_HOSTS, 1 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_race_delhosts_config, { 0, 0, 0, 0, 0, 0, 0, 0 },
		(vfp) test_slave_null, { 0, 0, 0, 0, 0, 0, 0, 0 } },
	{ "pvm_hostsync()",
		{ 0, ALL_HOSTS, ALL_HOSTS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_hostsync, { 0, 0, 0, 0, 0, 0, 0, 0 },
		(vfp) test_slave_null, { 0, 0, 0, 0, 0, 0, 0, 0 } },
	{ "pvm_pstat() correct",
		{ 0, 1, 1 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_pstat_correct, { 0, 0, 0, 0, 0, 0, 0, 0 },
		(vfp) test_slave_null, { 0, 0, 0, 0, 0, 0, 0, 0 } },
	{ "pvm_pstat() incorrect",
		{ 0, 1, 1 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_pstat_incorrect, { 0, 0, 0, 0, 0, 0, 0, 0 },
		(vfp) test_slave_null, { 0, 0, 0, 0, 0, 0, 0, 0 } },
	{ "pvm_spawn() sequential",
		{ 0, ALL_ARCHS, ALL_ARCHS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_spawn, { 0, 0, 0, 0, 0, 0, 0, 0 },
		(vfp) test_slave_ack, { NOWAIT, BLOCK, SEND, RECV,
			0, 0, 0, 0 } },
	{ "pvm_spawn() simultaneous",
		{ 0, ALL_ARCHS, ALL_ARCHS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_spawn_simul, { 0, 0, 0, 0, 0, 0, 0, 0 },
		(vfp) test_slave_ack, { NOWAIT, BLOCK, SEND, RECV,
			0, 0, 0, 0 } },
	{ "pvm_kill() correct",
		{ 0, ALL_ARCHS, ALL_ARCHS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_kill_correct, { 0, 0, 0, 0, 0, 0, 0, 0 },
		(vfp) test_slave_ack, { NOWAIT, BLOCK, SEND, RECV,
			0, 0, 0, 0 } },
	{ "pvm_kill() incorrect",
		{ 0, ALL_ARCHS, ALL_ARCHS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_kill_incorrect, { 0, 0, 0, 0, 0, 0, 0, 0 },
		(vfp) test_slave_ack, { NOWAIT, BLOCK, SEND, RECV,
			0, 0, 0, 0 } },
	{ "pvm_tidtohost()",
		{ 0, ALL_HOSTS, ALL_HOSTS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_tidtohost, { 0, 0, 0, 0, 0, 0, 0, 0 },
		(vfp) test_slave_ack, { NOWAIT, BLOCK, SEND, RECV,
			0, 0, 0, 0 } },
	{ "pvm_parent()",
		{ 0, ALL_ARCHS, ALL_ARCHS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_parent, { 0, 0, 0, 0, 0, 0, 0, 0 },
		(vfp) test_parent_slave, { SEND, 0, 0, 0, 0, 0, 0, 0 } },
	{ "pvm_sendsig()",
		{ 0, ALL_ARCHS, ALL_ARCHS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_sendsig, { 0, 0, 0, 0, 0, 0, 0, 0 },
		(vfp) test_sendsig_slave, { 0, 0, 0, 0, 0, 0, 0, 0 } },
	{ "pvm_tasks()",
		{ 0, ALL_ARCHS, ALL_ARCHS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_tasks, { 0, 0, 0, 0, 0, 0, 0, 0 },
		(vfp) test_slave_ack, { NOWAIT, BLOCK, SEND, RECV,
			0, 0, 0, 0 } },
	{ "pvm_exit()",
		{ 0, ALL_ARCHS, ALL_ARCHS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_exit, { 0, 0, 0, 0, 0, 0, 0, 0 },
		(vfp) test_slave_ack, { NOWAIT, NOBLOCK, SEND, RECV,
			0, 0, 0, 0 } },
	{ "several group servers started ?",
		{ 0, ALL_HOSTS, ALL_HOSTS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_multi_pvmgs, { 0, 0, 0, 0, 0, 0, 0, 0 },
		(vfp) test_slave_group, { BLOCK, SEND, 0, 0, 0, 0, 0, 0 } },
	{ "pvm_joingroup incorrect",
		{ 0, 1, 1 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_joingroup_incorrect, { 0, 0, 0, 0, 0, 0, 0, 0 },
		(vfp) test_slave_null, { 0, 0, 0, 0, 0, 0, 0, 0 } },
	{ "pvm_lvgroup incorrect",
		{ 0, 1, 1 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_lvgroup_incorrect, { 0, 0, 0, 0, 0, 0, 0, 0 },
		(vfp) test_slave_null, { 0, 0, 0, 0, 0, 0, 0, 0 } },
	{ "pvm_joingroup() pvm_lvgroup() pvm_gsize()",
		{ 0, ALL_HOSTS, ALL_HOSTS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_gsize, { 0, 0, 0, 0, 0, 0, 0, 0 },
		(vfp) test_slave_group, { BLOCK, SEND, 0, 0, 0, 0, 0, 0 } },
	{ "group completion",
		{ 0, ALL_HOSTS, ALL_HOSTS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_group_cleanup, { 0, 0, 0, 0, 0, 0, 0, 0 },
		(vfp) test_slave_group, { NOBLOCK, SEND, 0, 0, 0, 0, 0, 0 } },
	{ "pvm_getinst() pvm_gettid()",
		{ 0, ALL_HOSTS, ALL_HOSTS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_getinst_gettid, { 0, 0, 0, 0, 0, 0, 0, 0 },
		(vfp) test_slave_group, { BLOCK, SEND, 0, 0, 0, 0, 0, 0 } },
	{ "pvm_initsend() getsbuf() freebuf()",
		{ 0, 1, 1 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_buffer, { 0, 0, 0, 0, 0, 0, 0, 0 },
		(vfp) test_slave_null, { 0, 0, 0, 0, 0, 0, 0, 0 } },
	{ "pvm_pk/pvm_upk() SEND-RECV 1 PvmDataDefault",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_packing, { SEND, RECV, 1, PvmDataDefault,
			0, 0, 0, 0 },
		(vfp) test_packing_slave, { SEND, RECV, 1, PvmDataDefault,
			0, 0, 0, 0 } },
	{ "pvm_pk/pvm_upk() SEND-RECV 2 PvmDataDefault",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_packing, { SEND, RECV, 2, PvmDataDefault,
			0, 0, 0, 0 },
		(vfp) test_packing_slave, { SEND, RECV, 2, PvmDataDefault,
			0, 0, 0, 0 } },
	{ "pvm_pk/pvm_upk() SEND-RECV 4 PvmDataDefault",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_packing, { SEND, RECV, 4, PvmDataDefault,
			0, 0, 0, 0 },
		(vfp) test_packing_slave, { SEND, RECV, 4, PvmDataDefault,
			0, 0, 0, 0 } },
	{ "pvm_pk/pvm_upk() SEND-RECV 10 PvmDataDefault",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_packing, { SEND, RECV, 10, PvmDataDefault,
			0, 0, 0, 0 },
		(vfp) test_packing_slave, { SEND, RECV, 10, PvmDataDefault,
			0, 0, 0, 0 } },
	{ "pvm_pk/pvm_upk() SEND-RECV 100 PvmDataDefault",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_packing, { SEND, RECV, 100, PvmDataDefault,
			0, 0, 0, 0 },
		(vfp) test_packing_slave, { SEND, RECV, 100, PvmDataDefault,
			0, 0, 0, 0 } },
	{ "pvm_pk/pvm_upk() SEND-RECV 1000 PvmDataDefault",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_packing, { SEND, RECV, 1000, PvmDataDefault,
			0, 0, 0, 0 },
		(vfp) test_packing_slave, { SEND, RECV, 1000, PvmDataDefault,
			0, 0, 0, 0 } },
	{ "pvm_pk/pvm_upk() SEND-RECV 1 PvmDataDefault PACKF",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_packing, { SENDF, RECV, 1, PvmDataDefault,
			0, 0, 0, 0 },
		(vfp) test_packing_slave, { SENDF, RECV, 1, PvmDataDefault,
			0, 0, 0, 0 } },
	{ "pvm_pk/pvm_upk() SEND-RECV 2 PvmDataDefault PACKF",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_packing, { SENDF, RECV, 2, PvmDataDefault,
			0, 0, 0, 0 },
		(vfp) test_packing_slave, { SENDF, RECV, 2, PvmDataDefault,
			0, 0, 0, 0 } },
	{ "pvm_pk/pvm_upk() SEND-RECV 4 PvmDataDefault PACKF",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_packing, { SENDF, RECV, 4, PvmDataDefault,
			0, 0, 0, 0 },
		(vfp) test_packing_slave, { SENDF, RECV, 4, PvmDataDefault,
			0, 0, 0, 0 } },
	{ "pvm_pk/pvm_upk() SEND-RECV 10 PvmDataDefault PACKF",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_packing, { SENDF, RECV, 10, PvmDataDefault,
			0, 0, 0, 0 },
		(vfp) test_packing_slave, { SENDF, RECV, 10, PvmDataDefault,
			0, 0, 0, 0 } },
	{ "pvm_pk/pvm_upk() SEND-RECV 100 PvmDataDefault PACKF",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_packing, { SENDF, RECV, 100, PvmDataDefault,
			0, 0, 0, 0 },
		(vfp) test_packing_slave, { SENDF, RECV, 100, PvmDataDefault,
			0, 0, 0, 0 } },
	{ "pvm_pk/pvm_upk() SEND-RECV 1000 PvmDataDefault PACKF",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_packing, { SENDF, RECV, 1000, PvmDataDefault,
			0, 0, 0, 0 },
		(vfp) test_packing_slave, { SENDF, RECV, 1000, PvmDataDefault,
			0, 0, 0, 0 } },
	{ "pvm_pk/pvm_upk() SEND-RECV 1 PvmDataDefault UNPACKF",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_packing, { SEND, RECVF, 1, PvmDataDefault,
			0, 0, 0, 0 },
		(vfp) test_packing_slave, { SEND, RECVF, 1, PvmDataDefault,
			0, 0, 0, 0 } },
	{ "pvm_pk/pvm_upk() SEND-RECV 2 PvmDataDefault UNPACKF",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_packing, { SEND, RECVF, 2, PvmDataDefault,
			0, 0, 0, 0 },
		(vfp) test_packing_slave, { SEND, RECVF, 2, PvmDataDefault,
			0, 0, 0, 0 } },
	{ "pvm_pk/pvm_upk() SEND-RECV 4 PvmDataDefault UNPACKF",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_packing, { SEND, RECVF, 4, PvmDataDefault,
			0, 0, 0, 0 },
		(vfp) test_packing_slave, { SEND, RECVF, 4, PvmDataDefault,
			0, 0, 0, 0 } },
	{ "pvm_pk/pvm_upk() SEND-RECV 10 PvmDataDefault UNPACKF",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_packing, { SEND, RECVF, 10, PvmDataDefault,
			0, 0, 0, 0 },
		(vfp) test_packing_slave, { SEND, RECVF, 10, PvmDataDefault,
			0, 0, 0, 0 } },
	{ "pvm_pk/pvm_upk() SEND-RECV 100 PvmDataDefault UNPACKF",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_packing, { SEND, RECVF, 100, PvmDataDefault,
			0, 0, 0, 0 },
		(vfp) test_packing_slave, { SEND, RECVF, 100, PvmDataDefault,
			0, 0, 0, 0 } },
	{ "pvm_pk/pvm_upk() SEND-RECV 1000 PvmDataDefault UNPACKF",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_packing, { SEND, RECVF, 1000, PvmDataDefault,
			0, 0, 0, 0 },
		(vfp) test_packing_slave, { SEND, RECVF, 1000, PvmDataDefault,
			0, 0, 0, 0 } },
	{ "pvm_pk/pvm_upk() SEND-RECV 1 PvmDataDefault PACKF/UNPACKF",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_packing, { SENDF, RECVF, 1, PvmDataDefault,
			0, 0, 0, 0 },
		(vfp) test_packing_slave, { SENDF, RECVF, 1, PvmDataDefault,
			0, 0, 0, 0 } },
	{ "pvm_pk/pvm_upk() SEND-RECV 2 PvmDataDefault PACKF/UNPACKF",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_packing, { SENDF, RECVF, 2, PvmDataDefault,
			0, 0, 0, 0 },
		(vfp) test_packing_slave, { SENDF, RECVF, 2, PvmDataDefault,
			0, 0, 0, 0 } },
	{ "pvm_pk/pvm_upk() SEND-RECV 4 PvmDataDefault PACKF/UNPACKF",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_packing, { SENDF, RECVF, 4, PvmDataDefault,
			0, 0, 0, 0 },
		(vfp) test_packing_slave, { SENDF, RECVF, 4, PvmDataDefault,
			0, 0, 0, 0 } },
	{ "pvm_pk/pvm_upk() SEND-RECV 10 PvmDataDefault PACKF/UNPACKF",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_packing, { SENDF, RECVF, 10, PvmDataDefault,
			0, 0, 0, 0 },
		(vfp) test_packing_slave, { SENDF, RECVF, 10, PvmDataDefault,
			0, 0, 0, 0 } },
	{ "pvm_pk/pvm_upk() SEND-RECV 100 PvmDataDefault PACKF/UNPACKF",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_packing, { SENDF, RECVF, 100, PvmDataDefault,
			0, 0, 0, 0 },
		(vfp) test_packing_slave, { SENDF, RECVF, 100, PvmDataDefault,
			0, 0, 0, 0 } },
	{ "pvm_pk/pvm_upk() SEND-RECV 1000 PvmDataDefault PACKF/UNPACKF",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_packing, { SENDF, RECVF, 1000, PvmDataDefault,
			0, 0, 0, 0 },
		(vfp) test_packing_slave, { SENDF, RECVF, 1000, PvmDataDefault,
			0, 0, 0, 0 } },
	{ "pvm_pk/pvm_upk() SEND-RECV 1 PvmDataRaw",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_packing, { SEND, RECV, 1, PvmDataRaw,
			0, 0, 0, 0 },
		(vfp) test_packing_slave, { SEND, RECV, 1, PvmDataRaw,
			0, 0, 0, 0 } },
	{ "pvm_pk/pvm_upk() SEND-NRECV 2 PvmDataRaw",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_packing, { SEND, NRECV, 2, PvmDataRaw,
			0, 0, 0, 0 },
		(vfp) test_packing_slave, { SEND, NRECV, 2, PvmDataRaw,
			0, 0, 0, 0 } },
	{ "pvm_pk/pvm_upk() SEND-TRECV 4 PvmDataRaw",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_packing, { SEND, TRECV, 4, PvmDataRaw,
			0, 0, 0, 0 },
		(vfp) test_packing_slave, { SEND, TRECV, 4, PvmDataRaw,
			0, 0, 0, 0 } },
	{ "pvm_pk/pvm_upk() SEND-RECV 10 PvmDataRaw",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_packing, { SEND, RECV, 10, PvmDataRaw,
			0, 0, 0, 0 },
		(vfp) test_packing_slave, { SEND, RECV, 10, PvmDataRaw,
			0, 0, 0, 0 } },
	{ "pvm_pk/pvm_upk() SEND-NRECV 100 PvmDataRaw",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_packing, { SEND, NRECV, 100, PvmDataRaw,
			0, 0, 0, 0 },
		(vfp) test_packing_slave, { SEND, NRECV, 100, PvmDataRaw,
			0, 0, 0, 0 } },
	{ "pvm_pk/pvm_upk() SEND-TRECV 1000 PvmDataRaw",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_packing, { SEND, TRECV, 1000, PvmDataRaw,
			0, 0, 0, 0 },
		(vfp) test_packing_slave, { SEND, TRECV, 1000, PvmDataRaw,
			0, 0, 0, 0 } },
	{ "pvm_pk/pvm_upk() PSEND-PRECV 1",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_packing, { PSEND, PRECV, 1, 0, 0, 0, 0, 0 },
		(vfp) test_packing_slave, { PSEND, PRECV, 1, 0, 0, 0, 0, 0 } },
	{ "pvm_pk/pvm_upk() PSEND-PRECV 2",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_packing, { PSEND, PRECV, 2, 0, 0, 0, 0, 0 },
		(vfp) test_packing_slave, { PSEND, PRECV, 2, 0, 0, 0, 0, 0 } },
	{ "pvm_pk/pvm_upk() PSEND-PRECV 4",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_packing, { PSEND, PRECV, 4, 0, 0, 0, 0, 0 },
		(vfp) test_packing_slave, { PSEND, PRECV, 4, 0, 0, 0, 0, 0 } },
	{ "pvm_pk/pvm_upk() PSEND-PRECV 10",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_packing, { PSEND, PRECV, 10, 0, 0, 0, 0, 0 },
		(vfp) test_packing_slave, { PSEND, PRECV, 10, 0, 0, 0, 0, 0 } },
	{ "pvm_pk/pvm_upk() PSEND-PRECV 100",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_packing, { PSEND, PRECV, 100, 0, 0, 0, 0, 0 },
		(vfp) test_packing_slave, { PSEND, PRECV, 100,
			0, 0, 0, 0, 0 } },
	{ "pvm_pk/pvm_upk() PSEND-PRECV 1000",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_packing, { PSEND, PRECV, 1000, 0, 0, 0, 0, 0 },
		(vfp) test_packing_slave, { PSEND, PRECV, 1000,
			0, 0, 0, 0, 0 } },
	{ "pvm_pk/pvm_upk() PSEND-RECV 1",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_packing, { PSEND, RECV, 1, 0, 0, 0, 0, 0 },
		(vfp) test_packing_slave, { PSEND, RECV, 1, 0, 0, 0, 0, 0 } },
	{ "pvm_pk/pvm_upk() PSEND-RECV 2",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_packing, { PSEND, RECV, 2, 0, 0, 0, 0, 0 },
		(vfp) test_packing_slave, { PSEND, RECV, 2, 0, 0, 0, 0, 0 } },
	{ "pvm_pk/pvm_upk() PSEND-RECV 4",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_packing, { PSEND, RECV, 4, 0, 0, 0, 0, 0 },
		(vfp) test_packing_slave, { PSEND, RECV, 4, 0, 0, 0, 0, 0 } },
	{ "pvm_pk/pvm_upk() PSEND-RECV 10",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_packing, { PSEND, RECV, 10, 0, 0, 0, 0, 0 },
		(vfp) test_packing_slave, { PSEND, RECV, 10, 0, 0, 0, 0, 0 } },
	{ "pvm_pk/pvm_upk() PSEND-RECV 100",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_packing, { PSEND, RECV, 100, 0, 0, 0, 0, 0 },
		(vfp) test_packing_slave, { PSEND, RECV, 100, 0, 0, 0, 0, 0 } },
	{ "pvm_pk/pvm_upk() PSEND-RECV 1000",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_packing, { PSEND, RECV, 1000, 0, 0, 0, 0, 0 },
		(vfp) test_packing_slave, { PSEND, RECV, 1000,
			0, 0, 0, 0, 0 } },
	{ "pvm_pk/pvm_upk() SEND-PRECV 1",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_packing, { SEND, PRECV, 1, PvmDataRaw,
			0, 0, 0, 0 },
		(vfp) test_packing_slave, { SEND, PRECV, 1, PvmDataRaw,
			0, 0, 0, 0 } },
	{ "pvm_pk/pvm_upk() SEND-PRECV 2",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_packing, { SEND, PRECV, 2, PvmDataRaw,
			0, 0, 0, 0 },
		(vfp) test_packing_slave, { SEND, PRECV, 2, PvmDataRaw,
			0, 0, 0, 0 } },
	{ "pvm_pk/pvm_upk() SEND-PRECV 4",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_packing, { SEND, PRECV, 4, PvmDataRaw,
			0, 0, 0, 0 },
		(vfp) test_packing_slave, { SEND, PRECV, 4, PvmDataRaw,
			0, 0, 0, 0 } },
	{ "pvm_pk/pvm_upk() SEND-PRECV 10",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_packing, { SEND, PRECV, 10, PvmDataRaw,
			0, 0, 0, 0 },
		(vfp) test_packing_slave, { SEND, PRECV, 10, PvmDataRaw,
			0, 0, 0, 0 } },
	{ "pvm_pk/pvm_upk() SEND-PRECV 100",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_packing, { SEND, PRECV, 100, PvmDataRaw,
			0, 0, 0, 0 },
		(vfp) test_packing_slave, { SEND, PRECV, 100, PvmDataRaw,
			0, 0, 0, 0 } },
	{ "pvm_pk/pvm_upk() SEND-PRECV 1000",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_packing, { SEND, PRECV, 1000, PvmDataRaw,
			0, 0, 0, 0 },
		(vfp) test_packing_slave, { SEND, PRECV, 1000, PvmDataRaw,
			0, 0, 0, 0 } },
	{ "pvm_getrbuf()",
		{ 0, ALL_ARCHS, ALL_ARCHS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_getrbuf, { 0, 0, 0, 0, 0, 0, 0, 0 },
		(vfp) test_slave_ack, { NOWAIT, BLOCK, SEND, RECV,
			0, 0, 0, 0 } },
	{ "pvm_bufinfo()",
		{ 0, ALL_ARCHS, ALL_ARCHS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_bufinfo, { 0, 0, 0, 0, 0, 0, 0, 0 },
		(vfp) test_bufinfo_slave, { 0, 0, 0, 0, 0, 0, 0, 0 } },
	{ "pvm_mytid()",
		{ 0, ALL_ARCHS, ALL_ARCHS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_mytid, { 0, 0, 0, 0, 0, 0, 0, 0 },
		(vfp) test_mytid_slave, { 0, 0, 0, 0, 0, 0, 0, 0 } },
	{ "pvm_mkbuf()",
		{ 0, 1, 1 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_mkbuf, { 0, 0, 0, 0, 0, 0, 0, 0 },
		(vfp) test_slave_null, { 0, 0, 0, 0, 0, 0, 0, 0 } },
	{ "send/recv coherency SEND-RECV",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_coherency, { SEND, RECV, 0, 0, 0, 0, 0, 0 },
		(vfp) test_coherency_slave, { SEND, RECV, 0, 0, 0, 0, 0, 0 } },
	{ "send/recv coherency PSEND-PRECV",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_coherency, { PSEND, PRECV, 0, 0, 0, 0, 0, 0 },
		(vfp) test_coherency_slave, { PSEND, PRECV,
			0, 0, 0, 0, 0, 0 } },
	{ "send/recv coherency PSEND-RECV",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_coherency, { PSEND, RECV, 0, 0, 0, 0, 0, 0 },
		(vfp) test_coherency_slave, { PSEND, RECV, 0, 0, 0, 0, 0, 0 } },
	{ "send/recv coherency SEND-PRECV",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_coherency, { SEND, PRECV, 0, 0, 0, 0, 0, 0 },
		(vfp) test_coherency_slave, { SEND, PRECV, 0, 0, 0, 0, 0, 0 } },
	{ "send/recv coherency MCAST-RECV",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_coherency, { MCAST, RECV, 0, 0, 0, 0, 0, 0 },
		(vfp) test_coherency_slave, { MCAST, RECV, 0, 0, 0, 0, 0, 0 } },
	{ "send/recv coherency SEND-NRECV",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_coherency, { SEND, NRECV, 0, 0, 0, 0, 0, 0 },
		(vfp) test_coherency_slave, { SEND, NRECV, 0, 0, 0, 0, 0, 0 } },
	{ "send/recv coherency SEND-TRECV",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_coherency, { SEND, TRECV, 0, 0, 0, 0, 0, 0 },
		(vfp) test_coherency_slave, { SEND, TRECV, 0, 0, 0, 0, 0, 0 } },
	{ "pvm_setsbuf()",
		{ 0, ALL_ARCHS, ALL_ARCHS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_setsbuf, { 0, 0, 0, 0, 0, 0, 0, 0 },
		(vfp) test_setsbuf_slave, { 0, 0, 0, 0, 0, 0, 0, 0 } },
	{ "pvm_setrbuf()",
		{ 0, ALL_ARCHS, ALL_ARCHS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_setrbuf, { 0, 0, 0, 0, 0, 0, 0, 0 },
		(vfp) test_setrbuf_slave, { 0, 0, 0, 0, 0, 0, 0, 0 } },
	{ "pvm_set?buf() incorrect",
		{ 0, 1, 1 }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_setbuf_incorrect, { 0, 0, 0, 0, 0, 0, 0, 0 },
		(vfp) test_slave_null, { 0, 0, 0, 0, 0, 0, 0, 0 } },
	{ "pvm_bcast()",
		{ 0, ALL_HOSTS, ALL_HOSTS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_bcast, { 0, 0, 0, 0, 0, 0, 0, 0 },
		(vfp) test_bcast_slave, { 0, 0, 0, 0, 0, 0, 0, 0 } },
	{ "pvm_barrier()",
		{ 0, ALL_HOSTS, ALL_HOSTS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_barrier, { 0, 0, 0, 0, 0, 0, 0, 0 },
		(vfp) test_barrier_slave, { 0, 0, 0, 0, 0, 0, 0, 0 } },
	{ "pvm_reduce()",
		{ 0, ALL_HOSTS, ALL_HOSTS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_reduce, { 0, 0, 0, 0, 0, 0, 0, 0 },
		(vfp) test_reduce_slave, { 0, 0, 0, 0, 0, 0, 0, 0 } },
	{ "pvm_gather()",
		{ 0, ALL_HOSTS, ALL_HOSTS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_gather, { 0, 0, 0, 0, 0, 0, 0, 0 },
		(vfp) test_gather_slave, { 0, 0, 0, 0, 0, 0, 0, 0 } },
	{ "pvm_scatter()",
		{ 0, ALL_HOSTS, ALL_HOSTS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_scatter, { 0, 0, 0, 0, 0, 0, 0, 0 },
		(vfp) test_scatter_slave, { 0, 0, 0, 0, 0, 0, 0, 0 } },
	{ "pvm_mcast()",
		{ 0, ALL_HOSTS, ALL_HOSTS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_mcast, { 0, 0, 0, 0, 0, 0, 0, 0 },
		(vfp) test_mcast_slave, { 0, 0, 0, 0, 0, 0, 0, 0 } },
	{ "pvm_trecv() RECV",
		{ 0, ALL_HOSTS, ALL_HOSTS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_trecv, { 0, 0, 0, 0, 0, 0, 0, 0 },
		(vfp) test_slave_ack, { WAIT, NOBLOCK, SEND, RECV,
			0, 0, 0, 0 } },
	{ "pvm_trecv() NRECV",
		{ 0, ALL_HOSTS, ALL_HOSTS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_trecv, { 0, 0, 0, 0, 0, 0, 0, 0 },
		(vfp) test_slave_ack, { WAIT, NOBLOCK, SEND, NRECV,
			0, 0, 0, 0 } },
	{ "pvm_trecv() TRECV",
		{ 0, ALL_HOSTS, ALL_HOSTS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_trecv, { 0, 0, 0, 0, 0, 0, 0, 0 },
		(vfp) test_slave_ack, { WAIT, NOBLOCK, SEND, TRECV,
			0, 0, 0, 0 } },
	{ "pvm_nrecv() RECV",
		{ 0, ALL_HOSTS, ALL_HOSTS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_nrecv, { 0, 0, 0, 0, 0, 0, 0, 0 },
		(vfp) test_slave_ack, { WAIT, NOBLOCK, SEND, RECV,
			0, 0, 0, 0 } },
	{ "pvm_nrecv() NRECV",
		{ 0, ALL_HOSTS, ALL_HOSTS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_nrecv, { 0, 0, 0, 0, 0, 0, 0, 0 },
		(vfp) test_slave_ack, { WAIT, NOBLOCK, SEND, NRECV,
			0, 0, 0, 0 } },
	{ "pvm_nrecv() TRECV",
		{ 0, ALL_HOSTS, ALL_HOSTS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_nrecv, { 0, 0, 0, 0, 0, 0, 0, 0 },
		(vfp) test_slave_ack, { WAIT, NOBLOCK, SEND, TRECV,
			0, 0, 0, 0 } },
	{ "pvm_*context() SEND-RECV",
		{ 0, ALL_HOSTS, ALL_HOSTS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_context, { SEND, RECV, PvmDataDefault,
			0, 0, 0, 0, 0 },
		(vfp) test_context_slave, { SEND, RECV, PvmDataDefault,
			0, 0, 0, 0, 0 } },
	{ "pvm_*context() SEND-NRECV",
		{ 0, ALL_HOSTS, ALL_HOSTS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_context, { SEND, NRECV, PvmDataDefault,
			0, 0, 0, 0, 0 },
		(vfp) test_context_slave, { SEND, NRECV, PvmDataDefault,
			0, 0, 0, 0, 0 } },
	{ "pvm_*context() SEND-TRECV",
		{ 0, ALL_HOSTS, ALL_HOSTS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_context, { SEND, TRECV, PvmDataDefault,
			0, 0, 0, 0, 0 },
		(vfp) test_context_slave, { SEND, TRECV, PvmDataDefault,
			0, 0, 0, 0, 0 } },
	{ "pvm_*context() MCAST-RECV",
		{ 0, ALL_HOSTS, ALL_HOSTS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_context, { MCAST, RECV, PvmDataDefault,
			0, 0, 0, 0, 0 },
		(vfp) test_context_slave, { MCAST, RECV, PvmDataDefault,
			0, 0, 0, 0, 0 } },
	{ "pvm_*context() PSEND-PRECV",
		{ 0, ALL_HOSTS, ALL_HOSTS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_context, { PSEND, PRECV, 0, 0, 0, 0, 0, 0 },
		(vfp) test_context_slave, { PSEND, PRECV, 0, 0, 0, 0, 0, 0 } },
	{ "pvm_*context() PSEND-RECV",
		{ 0, ALL_HOSTS, ALL_HOSTS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_context, { PSEND, RECV, 0, 0, 0, 0, 0, 0 },
		(vfp) test_context_slave, { PSEND, RECV, 0, 0, 0, 0, 0, 0 } },
	{ "pvm_*context() SEND-PRECV",
		{ 0, ALL_HOSTS, ALL_HOSTS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_context, { SEND, PRECV, PvmDataRaw,
			0, 0, 0, 0, 0 },
		(vfp) test_context_slave, { SEND, PRECV, PvmDataRaw,
			0, 0, 0, 0, 0 } },
	{ "pvm_*context() MCAST-PRECV",
		{ 0, ALL_HOSTS, ALL_HOSTS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_context, { MCAST, PRECV, PvmDataRaw,
			0, 0, 0, 0, 0 },
		(vfp) test_context_slave, { MCAST, PRECV, PvmDataRaw,
			0, 0, 0, 0, 0 } },
	{ "pvm_siblings() 1",
		{ 0, ALL_HOSTS, ALL_HOSTS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_siblings, { 1, 0, 0, 0, 0, 0, 0, 0 },
		(vfp) test_siblings_slave, { 0, 0, 0, 0, 0, 0, 0, 0 } },
	{ "pvm_siblings() 2",
		{ 0, ALL_HOSTS, ALL_HOSTS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_siblings, { 2, 0, 0, 0, 0, 0, 0, 0 },
		(vfp) test_siblings_slave, { 0, 0, 0, 0, 0, 0, 0, 0 } },
	{ "pvm_siblings() 4",
		{ 0, ALL_HOSTS, ALL_HOSTS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_siblings, { 4, 0, 0, 0, 0, 0, 0, 0 },
		(vfp) test_siblings_slave, { 0, 0, 0, 0, 0, 0, 0, 0 } },
	{ "pvm_siblings() 8",
		{ 0, ALL_HOSTS, ALL_HOSTS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_siblings, { 8, 0, 0, 0, 0, 0, 0, 0 },
		(vfp) test_siblings_slave, { 0, 0, 0, 0, 0, 0, 0, 0 } },
	{ "pvm_*mhf() SEND-RECV",
		{ 0, ALL_HOSTS, ALL_HOSTS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_mhf, { SEND, RECV, PvmDataDefault, 0, 0, 0, 0, 0 },
		(vfp) test_mhf_slave, { SEND, RECV, PvmDataDefault,
			0, 0, 0, 0, 0 } },
	{ "pvm_*mhf() SEND-NRECV",
		{ 0, ALL_HOSTS, ALL_HOSTS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_mhf, { SEND, NRECV, PvmDataDefault, 0, 0, 0, 0, 0 },
		(vfp) test_mhf_slave, { SEND, NRECV, PvmDataDefault,
			0, 0, 0, 0, 0 } },
	{ "pvm_*mhf() SEND-TRECV",
		{ 0, ALL_HOSTS, ALL_HOSTS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_mhf, { SEND, TRECV, PvmDataDefault, 0, 0, 0, 0, 0 },
		(vfp) test_mhf_slave, { SEND, TRECV, PvmDataDefault,
			0, 0, 0, 0, 0 } },
	{ "pvm_*mhf() MCAST-RECV",
		{ 0, ALL_HOSTS, ALL_HOSTS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_mhf, { MCAST, RECV, PvmDataDefault, 0, 0, 0, 0, 0 },
		(vfp) test_mhf_slave, { MCAST, RECV, PvmDataDefault,
			0, 0, 0, 0, 0 } },
	{ "pvm_*mhf() PSEND-PRECV",
		{ 0, ALL_HOSTS, ALL_HOSTS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_mhf, { PSEND, PRECV, PvmDataRaw, 0, 0, 0, 0, 0 },
		(vfp) test_mhf_slave, { PSEND, PRECV, PvmDataRaw,
			0, 0, 0, 0, 0 } },
	{ "pvm_*mhf() PSEND-RECV",
		{ 0, ALL_HOSTS, ALL_HOSTS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_mhf, { PSEND, RECV, 0, 0, 0, 0, 0, 0 },
		(vfp) test_mhf_slave, { PSEND, RECV, 0, 0, 0, 0, 0, 0 } },
	{ "pvm_*mhf() SEND-PRECV",
		{ 0, ALL_HOSTS, ALL_HOSTS }, NOT_YET_PROCESSED,
		TYPE_ROUTINE,
		(ifp) test_mhf, { SEND, PRECV, PvmDataRaw, 0, 0, 0, 0, 0 },
		(vfp) test_mhf_slave, { SEND, PRECV, PvmDataRaw,
			0, 0, 0, 0, 0 } },
	{ "latency-bandwidth SEND-RECV",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_PERF,
		(ifp) test_perf, { SEND, RECV, PvmDataDefault,
			0, 0, 0, 0, 0 },
		(vfp) test_perf_slave, { SEND, RECV, PvmDataDefault,
			0, 0, 0, 0, 0 } },
	{ "latency-bandwidth PSEND-PRECV",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_PERF,
		(ifp) test_perf, { PSEND, PRECV, 0, 0, 0, 0, 0, 0 },
		(vfp) test_perf_slave, { PSEND, PRECV, 0, 0, 0, 0, 0, 0 } },
	{ "latency-bandwidth SEND-PRECV",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_PERF,
		(ifp) test_perf, { SEND, PRECV, PvmDataRaw,
			0, 0, 0, 0, 0 },
		(vfp) test_perf_slave, { SEND, PRECV, PvmDataRaw,
			0, 0, 0, 0, 0 } },
	{ "latency-bandwidth PSEND-RECV",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_PERF,
		(ifp) test_perf, { PSEND, RECV, 0, 0, 0, 0, 0, 0 },
		(vfp) test_perf_slave, { PSEND, RECV, 0, 0, 0, 0, 0, 0 } },
	{ "pvm_notify",
		{ 0, 1, 1 }, NOT_YET_PROCESSED,
		TYPE_MESSAGING,
		(ifp) test_notify, { 0, 0, 0, 0, 0, 0, 0, 0 },
		(vfp) test_slave_ack, { WAIT, NOBLOCK, SEND, RECV,
			0, 0, 0, 0 } },
	{ "head-head Empty SEND daemon default",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_HEAD_NODATA,
		(ifp) test_head_head,
			{ EMPTY, SEND, RECV, PvmAllowDirect, PvmDataDefault,
				0, 0, 0 },
		(vfp) test_head_head_slave,
			{ EMPTY, SEND, RECV, PvmAllowDirect, PvmDataDefault,
				0, 0, 0 } },
	{ "head-head Empty SEND daemon Raw",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_HEAD_NODATA,
		(ifp) test_head_head,
			{ EMPTY, SEND, RECV, PvmAllowDirect, PvmDataRaw,
				0, 0, 0 },
		(vfp) test_head_head_slave,
			{ EMPTY, SEND, RECV, PvmAllowDirect, PvmDataRaw,
				0, 0, 0 } },
	{ "head-head Empty SEND daemon InPlace",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_HEAD_NODATA,
		(ifp) test_head_head,
			{ EMPTY, SEND, RECV, PvmAllowDirect, PvmDataInPlace,
				0, 0, 0 },
		(vfp) test_head_head_slave,
			{ EMPTY, SEND, RECV, PvmAllowDirect, PvmDataInPlace,
				0, 0, 0 } },
	{ "head-head Empty SEND direct default",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_HEAD_NODATA,
		(ifp) test_head_head,
			{ EMPTY, SEND, RECV, PvmRouteDirect, PvmDataDefault,
				0, 0, 0 },
		(vfp) test_head_head_slave,
			{ EMPTY, SEND, RECV, PvmRouteDirect, PvmDataDefault,
				0, 0, 0 } },
	{ "head-head Empty SEND direct Raw",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_HEAD_NODATA,
		(ifp) test_head_head,
			{ EMPTY, SEND, RECV, PvmRouteDirect, PvmDataRaw,
				0, 0, 0 },
		(vfp) test_head_head_slave,
			{ EMPTY, SEND, RECV, PvmRouteDirect, PvmDataRaw,
				0, 0, 0 } },
	{ "head-head Empty SEND direct InPlace",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_HEAD_NODATA,
		(ifp) test_head_head,
			{ EMPTY, SEND, RECV, PvmRouteDirect, PvmDataInPlace,
				0, 0, 0 },
		(vfp) test_head_head_slave,
			{ EMPTY, SEND, RECV, PvmRouteDirect, PvmDataInPlace,
				0, 0, 0 } },
	{ "head-head Empty PSEND daemon",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_HEAD_NODATA,
		(ifp) test_head_head,
			{ EMPTY, PSEND, PRECV, PvmAllowDirect, 0, 0, 0, 0 },
		(vfp) test_head_head_slave,
			{ EMPTY, PSEND, PRECV, PvmAllowDirect, 0, 0, 0, 0 } },
	{ "head-head Empty PSEND direct",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_HEAD_NODATA,
		(ifp) test_head_head,
			{ EMPTY, PSEND, PRECV, PvmRouteDirect, 0, 0, 0, 0 },
		(vfp) test_head_head_slave,
			{ EMPTY, PSEND, PRECV, PvmRouteDirect, 0, 0, 0, 0 } },
	{ "head-head Not_empty SEND daemon default",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_HEAD_DATA,
		(ifp) test_head_head,
			{ NOT_EMPTY, SEND, RECV, PvmAllowDirect, PvmDataDefault,
				0, 0, 0 },
		(vfp) test_head_head_slave,
			{ NOT_EMPTY, SEND, RECV, PvmAllowDirect, PvmDataDefault,
				0, 0, 0 } },
	{ "head-head Not_empty SEND daemon Raw",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_HEAD_DATA,
		(ifp) test_head_head,
			{ NOT_EMPTY, SEND, RECV, PvmAllowDirect, PvmDataRaw,
				0, 0, 0 },
		(vfp) test_head_head_slave,
			{ NOT_EMPTY, SEND, RECV, PvmAllowDirect, PvmDataRaw,
				0, 0, 0 } },
	{ "head-head Not_empty SEND daemon InPlace",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_HEAD_DATA,
		(ifp) test_head_head,
			{ NOT_EMPTY, SEND, RECV, PvmAllowDirect, PvmDataInPlace,
				0, 0, 0 },
		(vfp) test_head_head_slave,
			{ NOT_EMPTY, SEND, RECV, PvmAllowDirect, PvmDataInPlace,
				0, 0, 0 } },
	{ "head-head Not_empty SEND direct default",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_HEAD_DATA,
		(ifp) test_head_head,
			{ NOT_EMPTY, SEND, RECV, PvmRouteDirect, PvmDataDefault,
				0, 0, 0 },
		(vfp) test_head_head_slave,
			{ NOT_EMPTY, SEND, RECV, PvmRouteDirect, PvmDataDefault,
				0, 0, 0 } },
	{ "head-head Not_empty SEND direct Raw",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_HEAD_DATA,
		(ifp) test_head_head,
			{ NOT_EMPTY, SEND, RECV, PvmRouteDirect, PvmDataRaw,
				0, 0, 0 },
		(vfp) test_head_head_slave,
			{ NOT_EMPTY, SEND, RECV, PvmRouteDirect, PvmDataRaw,
				0, 0, 0 } },
	{ "head-head Not_empty SEND direct InPlace",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_HEAD_DATA,
		(ifp) test_head_head,
			{ NOT_EMPTY, SEND, RECV, PvmRouteDirect, PvmDataInPlace,
				0, 0, 0 },
		(vfp) test_head_head_slave,
			{ NOT_EMPTY, SEND, RECV, PvmRouteDirect, PvmDataInPlace,
				0, 0, 0 } },
	{ "head-head Not_empty PSEND daemon",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_HEAD_DATA,
		(ifp) test_head_head,
			{ NOT_EMPTY, PSEND, PRECV, PvmAllowDirect, 0, 0, 0, 0 },
		(vfp) test_head_head_slave,
			{ NOT_EMPTY, PSEND, PRECV, PvmAllowDirect, 0, 0, 0, 0 } },
	{ "head-head Not_empty PSEND direct",
		{ 0, 2, 2 }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_HEAD_DATA,
		(ifp) test_head_head,
			{ NOT_EMPTY, PSEND, PRECV, PvmRouteDirect, 0, 0, 0, 0 },
		(vfp) test_head_head_slave,
			{ NOT_EMPTY, PSEND, PRECV, PvmRouteDirect, 0, 0, 0, 0 } },
	{ "triangle Empty SEND daemon default",
		{ 0, 3, 3 }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_TRIANGLE_NODATA,
		(ifp) test_triangle,
			{ EMPTY, SEND, RECV, PvmAllowDirect, PvmDataDefault,
				0, 0, 0 },
		(vfp) test_triangle_slave,
			{ EMPTY, SEND, RECV, PvmAllowDirect, PvmDataDefault,
				0, 0, 0 } },
	{ "triangle Empty SEND daemon Raw",
		{ 0, 3, 3 }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_TRIANGLE_NODATA,
		(ifp) test_triangle,
			{ EMPTY, SEND, RECV, PvmAllowDirect, PvmDataRaw,
				0, 0, 0 },
		(vfp) test_triangle_slave,
			{ EMPTY, SEND, RECV, PvmAllowDirect, PvmDataRaw,
				0, 0, 0 } },
	{ "triangle Empty SEND daemon InPlace",
		{ 0, 3, 3 }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_TRIANGLE_NODATA,
		(ifp) test_triangle,
			{ EMPTY, SEND, RECV, PvmAllowDirect, PvmDataInPlace,
				0, 0, 0 },
		(vfp) test_triangle_slave,
			{ EMPTY, SEND, RECV, PvmAllowDirect, PvmDataInPlace,
				0, 0, 0 } },
	{ "triangle Empty SEND direct default",
		{ 0, 3, 3 }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_TRIANGLE_NODATA,
		(ifp) test_triangle,
			{ EMPTY, SEND, RECV, PvmRouteDirect, PvmDataDefault,
				0, 0, 0 },
		(vfp) test_triangle_slave,
			{ EMPTY, SEND, RECV, PvmRouteDirect, PvmDataDefault,
				0, 0, 0 } },
	{ "triangle Empty SEND direct Raw",
		{ 0, 3, 3 }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_TRIANGLE_NODATA,
		(ifp) test_triangle,
			{ EMPTY, SEND, RECV, PvmRouteDirect, PvmDataRaw,
				0, 0, 0 },
		(vfp) test_triangle_slave,
			{ EMPTY, SEND, RECV, PvmRouteDirect, PvmDataRaw,
				0, 0, 0 } },
	{ "triangle Empty SEND direct InPlace",
		{ 0, 3, 3 }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_TRIANGLE_NODATA,
		(ifp) test_triangle,
			{ EMPTY, SEND, RECV, PvmRouteDirect, PvmDataInPlace,
				0, 0, 0 },
		(vfp) test_triangle_slave,
			{ EMPTY, SEND, RECV, PvmRouteDirect, PvmDataInPlace,
				0, 0, 0 } },
	{ "triangle Empty PSEND daemon",
		{ 0, 3, 3 }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_TRIANGLE_NODATA,
		(ifp) test_triangle,
			{ EMPTY, PSEND, PRECV, PvmAllowDirect, 0, 0, 0, 0 },
		(vfp) test_triangle_slave,
			{ EMPTY, PSEND, PRECV, PvmAllowDirect, 0, 0, 0, 0 } },
	{ "triangle Empty PSEND direct",
		{ 0, 3, 3 }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_TRIANGLE_NODATA,
		(ifp) test_triangle,
			{ EMPTY, PSEND, PRECV, PvmRouteDirect, 0, 0, 0, 0 },
		(vfp) test_triangle_slave,
			{ EMPTY, PSEND, PRECV, PvmRouteDirect, 0, 0, 0, 0 } },
	{ "triangle Not_empty SEND daemon default",
		{ 0, 3, 3 }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_TRIANGLE_DATA,
		(ifp) test_triangle,
			{ NOT_EMPTY, SEND, RECV, PvmAllowDirect, PvmDataDefault,
				0, 0, 0 },
		(vfp) test_triangle_slave,
			{ NOT_EMPTY, SEND, RECV, PvmAllowDirect, PvmDataDefault,
				0, 0, 0 } },
	{ "triangle Not_empty SEND daemon Raw",
		{ 0, 3, 3 }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_TRIANGLE_DATA,
		(ifp) test_triangle,
			{ NOT_EMPTY, SEND, RECV, PvmAllowDirect, PvmDataRaw,
				0, 0, 0 },
		(vfp) test_triangle_slave,
			{ NOT_EMPTY, SEND, RECV, PvmAllowDirect, PvmDataRaw,
				0, 0, 0 } },
	{ "triangle Not_empty SEND daemon InPlace",
		{ 0, 3, 3 }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_TRIANGLE_DATA,
		(ifp) test_triangle,
			{ NOT_EMPTY, SEND, RECV, PvmAllowDirect, PvmDataInPlace,
				0, 0, 0 },
		(vfp) test_triangle_slave,
			{ NOT_EMPTY, SEND, RECV, PvmAllowDirect, PvmDataInPlace,
				0, 0, 0 } },
	{ "triangle Not_empty SEND direct default",
		{ 0, 3, 3 }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_TRIANGLE_DATA,
		(ifp) test_triangle,
			{ NOT_EMPTY, SEND, RECV, PvmRouteDirect, PvmDataDefault,
				0, 0, 0 },
		(vfp) test_triangle_slave,
			{ NOT_EMPTY, SEND, RECV, PvmRouteDirect, PvmDataDefault,
				0, 0, 0 } },
	{ "triangle Not_empty SEND direct Raw",
		{ 0, 3, 3 }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_TRIANGLE_DATA,
		(ifp) test_triangle,
			{ NOT_EMPTY, SEND, RECV, PvmRouteDirect, PvmDataRaw,
				0, 0, 0 },
		(vfp) test_triangle_slave,
			{ NOT_EMPTY, SEND, RECV, PvmRouteDirect, PvmDataRaw,
				0, 0, 0 } },
	{ "triangle Not_empty SEND direct InPlace",
		{ 0, 3, 3 }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_TRIANGLE_DATA,
		(ifp) test_triangle,
			{ NOT_EMPTY, SEND, RECV, PvmRouteDirect, PvmDataInPlace,
				0, 0, 0 },
		(vfp) test_triangle_slave,
			{ NOT_EMPTY, SEND, RECV, PvmRouteDirect, PvmDataInPlace,
				0, 0, 0 } },
	{ "triangle Not_empty PSEND daemon",
		{ 0, 3, 3 }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_TRIANGLE_DATA,
		(ifp) test_triangle,
			{ NOT_EMPTY, PSEND, PRECV, PvmAllowDirect,
				0, 0, 0, 0 },
		(vfp) test_triangle_slave,
			{ NOT_EMPTY, PSEND, PRECV, PvmAllowDirect,
				0, 0, 0, 0 } },
	{ "triangle Not_empty PSEND direct",
		{ 0, 3, 3 }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_TRIANGLE_DATA,
		(ifp) test_triangle,
			{ NOT_EMPTY, PSEND, PRECV, PvmRouteDirect,
				0, 0, 0, 0 },
		(vfp) test_triangle_slave,
			{ NOT_EMPTY, PSEND, PRECV, PvmRouteDirect,
				0, 0, 0, 0 } },
	{ "funneling Empty SEND daemon Default",
		{ 0, FUNNELING_DEFAULT, FUNNELING_DEFAULT }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_FUNNEL_NODATA,
		(ifp) test_funneling,
			{ EMPTY, SEND, RECV, PvmAllowDirect, PvmDataDefault,
				0, 0, 0 },
		(vfp) test_funneling_slave,
			{ EMPTY, SEND, RECV, PvmAllowDirect, PvmDataDefault,
				0, 0, 0 } },
	{ "funneling Empty SEND daemon Raw",
		{ 0, FUNNELING_DEFAULT, FUNNELING_DEFAULT }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_FUNNEL_NODATA,
		(ifp) test_funneling,
			{ EMPTY, SEND, RECV, PvmAllowDirect, PvmDataRaw,
				0, 0, 0 },
		(vfp) test_funneling_slave,
			{ EMPTY, SEND, RECV, PvmAllowDirect, PvmDataRaw,
				0, 0, 0 } },
	{ "funneling Empty SEND daemon InPlace",
		{ 0, FUNNELING_DEFAULT, FUNNELING_DEFAULT }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_FUNNEL_NODATA,
		(ifp) test_funneling,
			{ EMPTY, SEND, RECV, PvmAllowDirect, PvmDataInPlace,
				0, 0, 0 },
		(vfp) test_funneling_slave,
			{ EMPTY, SEND, RECV, PvmAllowDirect, PvmDataInPlace,
				0, 0, 0 } },
	{ "funneling Empty SEND direct Default",
		{ 0, FUNNELING_DEFAULT, FUNNELING_DEFAULT }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_FUNNEL_NODATA,
		(ifp) test_funneling,
			{ EMPTY, SEND, RECV, PvmRouteDirect, PvmDataDefault,
				0, 0, 0 },
		(vfp) test_funneling_slave,
			{ EMPTY, SEND, RECV, PvmRouteDirect, PvmDataDefault,
				0, 0, 0 } },
	{ "funneling Empty SEND direct Raw",
		{ 0, FUNNELING_DEFAULT, FUNNELING_DEFAULT }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_FUNNEL_NODATA,
		(ifp) test_funneling,
			{ EMPTY, SEND, RECV, PvmRouteDirect, PvmDataRaw,
				0, 0, 0 },
		(vfp) test_funneling_slave,
			{ EMPTY, SEND, RECV, PvmRouteDirect, PvmDataRaw,
				0, 0, 0 } },
	{ "funneling Empty SEND direct InPlace",
		{ 0, FUNNELING_DEFAULT, FUNNELING_DEFAULT }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_FUNNEL_NODATA,
		(ifp) test_funneling,
			{ EMPTY, SEND, RECV, PvmRouteDirect, PvmDataInPlace,
				0, 0, 0 },
		(vfp) test_funneling_slave,
			{ EMPTY, SEND, RECV, PvmRouteDirect, PvmDataInPlace,
				0, 0, 0 } },
	{ "funneling Empty MCAST daemon Default",
		{ 0, FUNNELING_DEFAULT, FUNNELING_DEFAULT }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_FUNNEL_NODATA,
		(ifp) test_funneling,
			{ EMPTY, MCAST, RECV, PvmAllowDirect, PvmDataDefault,
				0, 0, 0 },
		(vfp) test_funneling_slave,
			{ EMPTY, MCAST, RECV, PvmAllowDirect, PvmDataDefault,
				0, 0, 0 } },
	{ "funneling Empty MCAST daemon Raw",
		{ 0, FUNNELING_DEFAULT, FUNNELING_DEFAULT }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_FUNNEL_NODATA,
		(ifp) test_funneling,
			{ EMPTY, MCAST, RECV, PvmAllowDirect, PvmDataRaw,
				0, 0, 0 },
		(vfp) test_funneling_slave,
			{ EMPTY, MCAST, RECV, PvmAllowDirect, PvmDataRaw,
				0, 0, 0 } },
	{ "funneling Empty MCAST daemon InPlace",
		{ 0, FUNNELING_DEFAULT, FUNNELING_DEFAULT }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_FUNNEL_NODATA,
		(ifp) test_funneling,
			{ EMPTY, MCAST, RECV, PvmAllowDirect, PvmDataInPlace,
				0, 0, 0 },
		(vfp) test_funneling_slave,
			{ EMPTY, MCAST, RECV, PvmAllowDirect, PvmDataInPlace,
				0, 0, 0 } },
	{ "funneling Empty MCAST direct Default",
		{ 0, FUNNELING_DEFAULT, FUNNELING_DEFAULT }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_FUNNEL_NODATA,
		(ifp) test_funneling,
			{ EMPTY, MCAST, RECV, PvmRouteDirect, PvmDataDefault,
				0, 0, 0 },
		(vfp) test_funneling_slave,
			{ EMPTY, MCAST, RECV, PvmRouteDirect, PvmDataDefault,
				0, 0, 0 } },
	{ "funneling Empty MCAST direct Raw",
		{ 0, FUNNELING_DEFAULT, FUNNELING_DEFAULT }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_FUNNEL_NODATA,
		(ifp) test_funneling,
			{ EMPTY, MCAST, RECV, PvmRouteDirect, PvmDataRaw,
				0, 0, 0 },
		(vfp) test_funneling_slave,
			{ EMPTY, MCAST, RECV, PvmRouteDirect, PvmDataRaw,
				0, 0, 0 } },
	{ "funneling Empty MCAST direct InPlace",
		{ 0, FUNNELING_DEFAULT, FUNNELING_DEFAULT }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_FUNNEL_NODATA,
		(ifp) test_funneling,
			{ EMPTY, MCAST, RECV, PvmRouteDirect, PvmDataInPlace,
				0, 0, 0 },
		(vfp) test_funneling_slave,
			{ EMPTY, MCAST, RECV, PvmRouteDirect, PvmDataInPlace,
				0, 0, 0 } },
	{ "funneling Empty PSEND daemon",
		{ 0, FUNNELING_DEFAULT, FUNNELING_DEFAULT }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_FUNNEL_NODATA,
		(ifp) test_funneling,
			{ EMPTY, PSEND, PRECV, PvmAllowDirect, 0, 0, 0, 0 },
		(vfp) test_funneling_slave,
			{ EMPTY, PSEND, PRECV, PvmAllowDirect, 0, 0, 0, 0 } },
	{ "funneling Empty PSEND direct",
		{ 0, FUNNELING_DEFAULT, FUNNELING_DEFAULT }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_FUNNEL_NODATA,
		(ifp) test_funneling,
			{ EMPTY, PSEND, PRECV, PvmRouteDirect, 0, 0, 0, 0 },
		(vfp) test_funneling_slave,
			{ EMPTY, PSEND, PRECV, PvmRouteDirect, 0, 0, 0, 0 } },
	{ "funneling Not_empty SEND daemon Default",
		{ 0, FUNNELING_DEFAULT, FUNNELING_DEFAULT }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_FUNNEL_DATA,
		(ifp) test_funneling,
			{ NOT_EMPTY, SEND, RECV, PvmAllowDirect, PvmDataDefault,
				0, 0, 0 },
		(vfp) test_funneling_slave,
			{ NOT_EMPTY, SEND, RECV, PvmAllowDirect, PvmDataDefault,
				0, 0, 0 } },
	{ "funneling Not_empty SEND daemon Raw",
		{ 0, FUNNELING_DEFAULT, FUNNELING_DEFAULT }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_FUNNEL_DATA,
		(ifp) test_funneling,
			{ NOT_EMPTY, SEND, RECV, PvmAllowDirect, PvmDataRaw,
				0, 0, 0 },
		(vfp) test_funneling_slave,
			{ NOT_EMPTY, SEND, RECV, PvmAllowDirect, PvmDataRaw,
				0, 0, 0 } },
	{ "funneling Not_empty SEND daemon InPlace",
		{ 0, FUNNELING_DEFAULT, FUNNELING_DEFAULT }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_FUNNEL_DATA,
		(ifp) test_funneling,
			{ NOT_EMPTY, SEND, RECV, PvmAllowDirect, PvmDataInPlace,
				0, 0, 0 },
		(vfp) test_funneling_slave,
			{ NOT_EMPTY, SEND, RECV, PvmAllowDirect, PvmDataInPlace,
				0, 0, 0 } },
	{ "funneling Not_empty SEND direct Default",
		{ 0, FUNNELING_DEFAULT, FUNNELING_DEFAULT }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_FUNNEL_DATA,
		(ifp) test_funneling,
			{ NOT_EMPTY, SEND, RECV, PvmRouteDirect, PvmDataDefault,
				0, 0, 0 },
		(vfp) test_funneling_slave,
			{ NOT_EMPTY, SEND, RECV, PvmRouteDirect, PvmDataDefault,
				0, 0, 0 } },
	{ "funneling Not_empty SEND direct Raw",
		{ 0, FUNNELING_DEFAULT, FUNNELING_DEFAULT }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_FUNNEL_DATA,
		(ifp) test_funneling,
			{ NOT_EMPTY, SEND, RECV, PvmRouteDirect, PvmDataRaw,
				0, 0, 0 },
		(vfp) test_funneling_slave,
			{ NOT_EMPTY, SEND, RECV, PvmRouteDirect, PvmDataRaw,
				0, 0, 0 } },
	{ "funneling Not_empty SEND direct InPlace",
		{ 0, FUNNELING_DEFAULT, FUNNELING_DEFAULT }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_FUNNEL_DATA,
		(ifp) test_funneling,
			{ NOT_EMPTY, SEND, RECV, PvmRouteDirect, PvmDataInPlace,
				0, 0, 0 },
		(vfp) test_funneling_slave,
			{ NOT_EMPTY, SEND, RECV, PvmRouteDirect, PvmDataInPlace,
				0, 0, 0 } },
	{ "funneling Not_empty MCAST daemon Default",
		{ 0, FUNNELING_DEFAULT, FUNNELING_DEFAULT }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_FUNNEL_DATA,
		(ifp) test_funneling,
			{ NOT_EMPTY, MCAST, RECV, PvmAllowDirect, PvmDataDefault,
				0, 0, 0 },
		(vfp) test_funneling_slave,
			{ NOT_EMPTY, MCAST, RECV, PvmAllowDirect, PvmDataDefault,
				0, 0, 0 } },
	{ "funneling Not_empty MCAST daemon Raw",
		{ 0, FUNNELING_DEFAULT, FUNNELING_DEFAULT }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_FUNNEL_DATA,
		(ifp) test_funneling,
			{ NOT_EMPTY, MCAST, RECV, PvmAllowDirect, PvmDataRaw,
				0, 0, 0 },
		(vfp) test_funneling_slave,
			{ NOT_EMPTY, MCAST, RECV, PvmAllowDirect, PvmDataRaw,
				0, 0, 0 } },
	{ "funneling Not_empty MCAST daemon InPlace",
		{ 0, FUNNELING_DEFAULT, FUNNELING_DEFAULT }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_FUNNEL_DATA,
		(ifp) test_funneling,
			{ NOT_EMPTY, MCAST, RECV, PvmAllowDirect, PvmDataInPlace,
				0, 0, 0 },
		(vfp) test_funneling_slave,
			{ NOT_EMPTY, MCAST, RECV, PvmAllowDirect, PvmDataInPlace,
				0, 0, 0 } },
	{ "funneling Not_empty MCAST direct Default",
		{ 0, FUNNELING_DEFAULT, FUNNELING_DEFAULT }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_FUNNEL_DATA,
		(ifp) test_funneling,
			{ NOT_EMPTY, MCAST, RECV, PvmRouteDirect, PvmDataDefault,
				0, 0, 0 },
		(vfp) test_funneling_slave,
			{ NOT_EMPTY, MCAST, RECV, PvmRouteDirect, PvmDataDefault,
				0, 0, 0 } },
	{ "funneling Not_empty MCAST direct Raw",
		{ 0, FUNNELING_DEFAULT, FUNNELING_DEFAULT }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_FUNNEL_DATA,
		(ifp) test_funneling,
			{ NOT_EMPTY, MCAST, RECV, PvmRouteDirect, PvmDataRaw,
				0, 0, 0 },
		(vfp) test_funneling_slave,
			{ NOT_EMPTY, MCAST, RECV, PvmRouteDirect, PvmDataRaw,
				0, 0, 0 } },
	{ "funneling Not_empty MCAST direct InPlace",
		{ 0, FUNNELING_DEFAULT, FUNNELING_DEFAULT }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_FUNNEL_DATA,
		(ifp) test_funneling,
			{ NOT_EMPTY, MCAST, RECV, PvmRouteDirect, PvmDataInPlace,
				0, 0, 0 },
		(vfp) test_funneling_slave,
			{ NOT_EMPTY, MCAST, RECV, PvmRouteDirect, PvmDataInPlace,
				0, 0, 0 } },
	{ "funneling Not_empty PSEND daemon",
		{ 0, FUNNELING_DEFAULT, FUNNELING_DEFAULT }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_FUNNEL_DATA,
		(ifp) test_funneling,
			{ NOT_EMPTY, PSEND, PRECV, PvmAllowDirect,
				0, 0, 0, 0 },
		(vfp) test_funneling_slave,
			{ NOT_EMPTY, PSEND, PRECV, PvmAllowDirect,
				0, 0, 0, 0 } },
	{ "funneling Not_empty PSEND direct",
		{ 0, FUNNELING_DEFAULT, FUNNELING_DEFAULT }, NOT_YET_PROCESSED,
		TYPE_MESSAGING | TYPE_FUNNEL_DATA,
		(ifp) test_funneling,
			{ NOT_EMPTY, PSEND, PRECV, PvmRouteDirect,
				0, 0, 0, 0 },
		(vfp) test_funneling_slave,
			{ NOT_EMPTY, PSEND, PRECV, PvmRouteDirect,
				0, 0, 0, 0 } }
};

int NUMBER_OF_TESTS =
	(int) ( sizeof( module_list) / sizeof( test_module ) );

