
static char rcsid[] =
	"$Id: pvm_test_slave.c,v 1.11 1997/07/21 15:00:20 pvmsrc Exp $";

/***************************/
/*  pvm_test_slave.c       */
/*  Generic slave          */
/***************************/

#include "pvm_test.h"
#include "globals.h"

int main( argc, argv )
int argc;
char **argv;
{
	int slave_args[NUM_ARGS];

	int index;
	int i;

	if ( argc < 2 )
	{
		fprintf( stderr, "Usage:  %s <test_num> <slave args ...>\n",
				argv[0] );
		exit( 1 );
	}

	index = atoi( argv[1] );

	/* Check for Version Slave */

	if ( index == VERSION_TEST )
	{
		pvm_initsend( PvmDataDefault );
		pvm_pkstr( pvm_version() );
		pvm_send( pvm_parent(), VERSION_TAG );
		exit( pvm_exit() );
	}

	/* Regular Tests */

	if ( index < 0 || index >= NUMBER_OF_TESTS )
	{
		fprintf( stderr, "%s:  Test Number %d Out Of Range [1-%d]\n",
				argv[0], index + 1, NUMBER_OF_TESTS );
		exit( 1 );
	}

	/***** Set Trecv Timeval *****/

	TRECV_TM.tv_sec = SEC_TRECV;
	TRECV_TM.tv_usec = 0;

	/* Collect Slave Args */

	for ( i=0 ; i < NUM_ARGS ; i++ )
		slave_args[i] = 0;

	for ( i=0 ; i < NUM_ARGS && i + 2 < argc ; i++ )
		slave_args[i] = atoi( argv[ 2 + i ] );

	MYPARENT = pvm_parent();
	CKERR_FP( stderr, MYPARENT, "pvm_parent", NOHOST, exit( 1 ) );

	module_list[ index ].proc_slave( index, slave_args );

	exit( 0 );
}

